import { Configuration, HotModuleReplacementPlugin } from 'webpack';
import ExtractCssChunks from 'mini-css-extract-plugin';
import dartSass from 'sass';
export declare function getLibWebpackConfig(buildConfig: IBuildConfig): Configuration;
export declare type IWebpackConfigParams = Pick<Configuration, 'name' | 'context' | 'entry' | 'externals' | 'resolveLoader' | 'resolve'> & {
    output: {
        path: string;
        filename: string;
        library: string;
        libraryTarget: string;
        publicPath: string;
        pathinfo: boolean;
        umdNamedDefine: boolean;
    };
};
export declare function getProdWebpackConfigByParams({ context, entry, output, externals, resolve, resolveLoader, name, }: IWebpackConfigParams): Configuration;
export declare function getDevWebpackConfigByParams({ context, entry, output, externals, resolve, resolveLoader, name }: any): {
    name: any;
    context: any;
    entry: any;
    output: any;
    externals: any;
    resolve: any;
    resolveLoader: any;
    module: {
        rules: ({
            test: RegExp;
            loader: string;
            options: {
                compact: boolean;
                presets: (string | (string | {
                    targets: {
                        chrome: string;
                    };
                })[])[];
                plugins: (string | (string | {
                    legacy: boolean;
                })[] | (string | {
                    proposal: string;
                })[])[];
            };
            use?: undefined;
        } | {
            test: RegExp;
            use: ({
                loader: string;
                options?: undefined;
            } | {
                loader: string;
                options: {
                    ident: string;
                    plugins: () => any[];
                    implementation?: undefined;
                };
            } | {
                loader: string;
                options: {
                    implementation: typeof dartSass;
                    ident?: undefined;
                    plugins?: undefined;
                };
            })[];
            loader?: undefined;
            options?: undefined;
        } | {
            test: RegExp;
            loader: string;
            options?: undefined;
            use?: undefined;
        })[];
    };
    plugins: (ExtractCssChunks | HotModuleReplacementPlugin)[];
    mode: string;
    optimization: {
        minimize: boolean;
    };
    devtool: string;
};
export declare type BuildMode = 'development' | 'production';
export declare type PathMap = {
    [name: string]: string;
};
export interface IBuildConfig {
    mode: BuildMode;
    name: string;
    version: string;
    title: string;
    description: string;
    rootPath: string;
    srcPath: string;
    tempPath: string;
    outputPath: string;
    mainEntryPath: string;
    controlEntryPath: string;
    manifestPath: string;
    lessEntryPath: string;
    componentDirPathMap: PathMap;
    pluginsDirPathMap: PathMap;
    actionsDirPathMap: PathMap;
}
export declare function getBuildConfig(rootPath: string, mode?: BuildMode): IBuildConfig;
export declare function getAllChildrenDirPathMap(srcPath: string, dir: string): PathMap;
//# sourceMappingURL=config.d.ts.map