"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeEntryTempFile = void 0;
const path = __importStar(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const util_1 = require("../../util");
async function writeEntryTempFile(buildConfig) {
    (0, util_1.info)('生成 entry 临时入口文件');
    const { mainEntryPath, controlEntryPath, componentDirPathMap, pluginsDirPathMap, actionsDirPathMap } = buildConfig;
    await fs_extra_1.default.writeFile(mainEntryPath, getMainExportsDeclare(componentDirPathMap, pluginsDirPathMap, actionsDirPathMap));
    await fs_extra_1.default.writeFile(controlEntryPath, getControlExportsDeclare(componentDirPathMap, pluginsDirPathMap, actionsDirPathMap));
}
exports.writeEntryTempFile = writeEntryTempFile;
function getMainExportsDeclare(componentDirPathMap, pluginsDirPathMap, actionsDirPathMap) {
    return `module.exports = {
    components: { ${pathMapToStr(componentDirPathMap, 'main')} },
    plugins: { ${pathMapToStr(pluginsDirPathMap, 'main')} },
    actions: { ${pathMapToStr(actionsDirPathMap, 'main')} },
  }`;
}
function getControlExportsDeclare(componentDirPathMap, pluginsDirPathMap, actionsDirPathMap) {
    return `module.exports = {
    components: [ ${pathMapToStr(componentDirPathMap, 'control')} ],
    plugins: [ ${pathMapToStr(pluginsDirPathMap, 'control')} ],
    actions: [ ${pathMapToStr(actionsDirPathMap, 'control')} ],
  }`;
}
function pathMapToStr(pathMap, type = 'main') {
    return Object.entries(pathMap)
        .map(([name, entry]) => {
        if (type === 'main') {
            return getMainRequireTemplateStr(name, entry);
        }
        return getControlRequireTemplateStr(name, entry);
    })
        .join(',\n');
}
function getMainRequireTemplateStr(name, entry) {
    return `'${name}': require('${(0, util_1.handlePathEscape)(path.resolve(entry, './index.js'))}').default`;
}
function getControlRequireTemplateStr(name, entry) {
    const tempArr = [];
    tempArr.push(`name: '${name}'`);
    tempArr.push(`...require('${(0, util_1.handlePathEscape)(path.resolve(entry, './control.js'))}').default`);
    // TODO remove duplicated meta
    tempArr.push(`meta: require('${(0, util_1.handlePathEscape)(path.resolve(entry, './meta.json'))}')`);
    // 增加 icon
    const iconPath = (0, util_1.handlePathEscape)(path.resolve(entry, './icon.svg'));
    if (fs_extra_1.default.existsSync(iconPath)) {
        tempArr.push(`icon: require('${iconPath}')`);
    }
    return `{${tempArr.join(',\n')}}`;
}
